
#include <pthread.h>
#include <unistd.h>

#include <cerrno>
#include <cstdlib>
#include <iomanip>
#include <iostream>
#include <stdexcept>

#include </tmp/c.hpp>

namespace {

	void *f(void *) {
		std::cerr << "new thread tid=" << pthread_self() << std::endl;
		return 0;
	}
	const size_t MB = 1024 * 1000;
}

char ppp[ MB * 2 ];
void *stackBuf = ppp;



int main( const int, const char **, const char ** )
try {

	pthread_t tid = 0;
	int rc = 0;

	/*
	stackBuf = malloc( MB + sysconf( _SC_PAGESIZE ) );
	if ( stackBuf == 0 ) {
		std::cerr << "failed malloc in main" << std::endl;
		return 1;
	}
	*/
	memset( stackBuf, 0, MB + 4096 );

	tid = mi_pthread_create( f );
	std::cerr << "new thread created tid=" << tid << std::endl;

	void *threadReturn = 0;
	rc = pthread_join( tid, & threadReturn );
	if ( rc != 0 ) {
		std::cerr << "pthread_join: " << strerror( rc ) << std::endl;
		return 1;
	}
	std::cerr << "join done." << std::endl;

	return 0;

} catch ( const std::exception& e ) {
	std::cerr << e.what() << std::endl;
	throw;
} catch ( ... ) {
	std::cerr << "Unknown exception."  << std::endl;
	throw;
}


